/**
 *  \file csp.h
 *  Csp osztály deklarációja
 */
#ifndef CSP_H
#define CSP_H

#include "obj.h"
/**
 * Csomópont osztály.
 * 3 kapcsolódási pontja van
 * Az egyik ponton bejövő jelet változtatás nélkül kiküldi a másik kettőre.
 */
class Csp :public Obj {
protected:
    Message veg[3];                         ///< három vége van
public:
    /// Ez a default konstruktor is
    /// @param n - objektum neve (alapértelmezése "")
    Csp(const char *n = "csp") : Obj(n, 3) {}        // létrehoz egy 3 végű objektumot

    /// Működést megvalósító virtuális függvény.
    /// A beérkező üzenet és a saját állapota alapján ki kell számítania a választ.
    /// @param k   - kapcsolódási pontra üzenet érkezett
    /// @param msg - beérkező üzenet
    void set(Pin n, Message msg);           ///< működést megvalósító függvény
};

#endif // CSP_H
