/**
 * \file virt_destruktor2.cpp
 *
 * \par Demonstrációs cél:
 * Virtuális függvények és virt. destruktor különbözőségének bemutatása.
 *
 * Event destruktora virtuális, ezért Event1 destruktora indul be.
 * Event1 destruktor lefutása után Event destruktora mindenképpen lefut,
 * mivel ennek a feladata a takarítás.
 *
 * Show esetében csak a származtatott Show fut. Amennyiben ez nem hívja
 * explicit az ős Show tagfüggvényét, akkor az nem fut le.
 *
 */

#include <iostream>
#include "printm.h"

using std::cout;
using std::endl;
using std::cin;

void msg(const char *txt) {
    cout << txt << endl;
}

struct Event {
    Event()             { msg("ctor: Event"); }
    virtual void show() { msg("show: Event"); }
    virtual ~Event()    { msg("dtor: Event"); }
    void f()            { msg("f: Event");    }
};

class Event1 :public Event {
    int *p;
public:
    Event1(int s) {
        msg("ctor: Event1");
        p = new int[s];
    }
    void show()         { msg("show: Event1"); }
    void f()            { msg("f: Event1"); }
    ~Event1() {
        msg("dtor: Event1");
        delete[] p;
    }
};

int main() {

                        { /// nyitunk egy blokkot
_(  Event1 e1(2);   )
_(  e1.f();         )
_(  e1.Event::f();  )
                        } /// blokk vége itt lefut a destruktor
    cin.ignore(1);

_(  Event *ep = new Event1(120);    )
_(  ep->show();     )
_(  ep->f();        )
_(  ep->Event::f(); )
_(  delete ep;      )
}
